!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Module HeatFlux
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: heatflux.f90,v 1.4 2006/07/12 12:00:52 sugiyama Exp $
!   * Tag Name: $Name: arare4-20060810 $
!   * Change History: 
!
!== Overview
!
!ǤΥեåη׻⥸塼
!
!== Error Handling
!
!== Bugs
!
!== Note
!
!  * 1.5 Υ㡼Ѥ
!  * 꼰 CReSS Υޥ˥奢򻲾Ȥ
!
!== Future Plans
!
!

module HeatFlux
  !
  !ǤΥեåη׻⥸塼
  !
  
  !⥸塼ɤ߹
  use gridset,  only: DimXMin,         & !x β
    &                 DimXMax,         & !x ξ
    &                 DimZMin,         & !z β
    &                 DimZMax,         & !z ξ
    &                 RegZMin,         & !z ʪΰβ
    &                 DelZ               !z γʻֳ
  use basicset, only: xz_ExnerBasicZ,  & !ʡؿδܾ
    &                 xz_PotTempBasicZ,& !̤δܾ
    &                 xz_TempBasicZ,   & !٤δܾ
    &                 TempSfc            !ɽ̲


  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public xz_HeatFluxBulk

  !ѿ
  real(8)  :: Bulk = 1.5d-3        !Ǯư̥եåΥХ륯

  !ͤ¸
  save Bulk

contains


!!!------------------------------------------------------------------------!!!
  function xz_HeatFluxBulk( xz_PotTemp, xz_Exner )
    !
    !ɽǮեå(ñ̤ W/m^2)Х륯ˡǷ׻. 
    !絤β٤ϴܾβ٤˸ꤷ, 
    !ޤʿ®٤ 100 m/s ˸ꤹ. 
    !
    !Ǯեå Cp \bar{ w} = Cm Cp V (Ta-TG)
    !ѷ, \bar{ w} = Cm V (a-G)
    !\DP{\bar{ w}}{z} = Cm V (a-G) /dz
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)   :: xz_PotTemp(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !̤ξʬ    
    real(8), intent(in)   :: xz_Exner(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ʡؿξʬ    
    real(8)               :: xz_HeatFluxBulk(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !ɽǮեå
    real(8)               :: xz_TempAll(DimXMin:DimXMax,DimZMin:DimZMax)
                                           !(ʿʬ+)
    real(8)  :: VelX = 100.0d0             !ؤǤοʿ®٤ᤦ

    !
    !  * Ƥͤ򥼥˸
    xz_HeatFluxBulk = 0.0d0
    
    !ɽǮեå׻
    !  * ñ̤ K/s
    !  * ʡؿϴܾͤɽ.     
    !  * ʻ xz Ǥ, ʪΰκǲüź RegZMin+1
    !    եå, RegZMin+1, RegZMin+2 Ǥͤκ㤵.
    !  * ಹ(ɽ̲) TempSfc ˤ.
    !
    xz_TempAll = (xz_PotTempBasicZ + xz_PotTemp) * (xz_ExnerBasicZ + xz_Exner)
    
    xz_HeatFluxBulk(:,RegZMin+1) =                                 &
      & - Bulk * VelX * min( xz_TempAll(:,RegZMin+1) - TempSfc, 0.0d0 ) / DelZ
    
  end function xz_HeatFluxBulk
  
end module HeatFlux
